VST 3 Examples VST 3.7 SDK for developing VST plug-in

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Properties Macros Groups Pages
Public Member Functions | Static Public Member Functions | Public Attributes | Protected Attributes | List of all members
Plug Class Reference

`#include <plug.h>`

Inheritance diagram for Plug:

## Public Member Functions
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | sendTextMessage (const char16 *text)
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
tresult | getPrefetchableSupport (PrefetchableSupport &prefetchable) SMTG_OVERRIDE
| Plug ()
tresult | initialize (FUnknown *context) SMTG_OVERRIDE
| Called at first after constructor.
tresult | process (ProcessData &data) SMTG_OVERRIDE
| Here we go...the process call.
tresult | setState (IBStream *state) SMTG_OVERRIDE
| For persistence.
tresult | getState (IBStream *state) SMTG_OVERRIDE
Public Member Functions inherited from AudioEffect
| AudioEffect ()
AudioBus * | addAudioInput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | addAudioOutput (const TChar *name, SpeakerArrangement arr, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
AudioBus * | getAudioInput (int32 index)
AudioBus * | getAudioOutput (int32 index)
EventBus * | addEventInput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | addEventOutput (const TChar *name, int32 channels=16, BusType busType=kMain, int32 flags=BusInfo::kDefaultActive)
EventBus * | getEventInput (int32 index)
EventBus * | getEventOutput (int32 index)
tresult | setBusArrangements (SpeakerArrangement *inputs, int32 numIns, SpeakerArrangement *outputs, int32 numOuts) SMTG_OVERRIDE
tresult | getBusArrangement (BusDirection dir, int32 busIndex, SpeakerArrangement &arr) SMTG_OVERRIDE
tresult | canProcessSampleSize (int32 symbolicSampleSize) SMTG_OVERRIDE
uint32 | getLatencySamples () SMTG_OVERRIDE
tresult | setupProcessing (ProcessSetup &setup) SMTG_OVERRIDE
tresult | setProcessing (TBool state) SMTG_OVERRIDE
uint32 | getTailSamples () SMTG_OVERRIDE
uint32 | getProcessContextRequirements () SMTG_OVERRIDE
| Component ()
void | setControllerClass (const FUID &cid)
void | setControllerClass (const TUID &cid)
tresult | removeAudioBusses ()
tresult | removeEventBusses ()
tresult | renameBus (MediaType type, BusDirection dir, int32 index, const String128 newName)
tresult | getControllerClassId (TUID classID) SMTG_OVERRIDE
tresult | setIoMode (IoMode mode) SMTG_OVERRIDE
int32 | getBusCount (MediaType type, BusDirection dir) SMTG_OVERRIDE
tresult | getBusInfo (MediaType type, BusDirection dir, int32 index, BusInfo &info) SMTG_OVERRIDE
tresult | getRoutingInfo (RoutingInfo &inInfo, RoutingInfo &outInfo) SMTG_OVERRIDE
tresult | activateBus (MediaType type, BusDirection dir, int32 index, TBool state) SMTG_OVERRIDE
tresult | setActive (TBool state) SMTG_OVERRIDE
tresult | terminate () SMTG_OVERRIDE
BusList * | getBusList (MediaType type, BusDirection dir)
tresult | removeAllBusses ()
| ComponentBase ()
| ~ComponentBase () override
FUnknown * | getHostContext () const
IConnectionPoint * | getPeer () const
IMessage * | allocateMessage () const
tresult | sendMessage (IMessage *message) const
tresult | sendTextMessage (const char8 *text) const
tresult | sendMessageID (const char8 *messageID) const
virtual tresult | receiveText (const char8 *text)
tresult | terminate () SMTG_OVERRIDE
tresult | connect (IConnectionPoint *other) SMTG_OVERRIDE
tresult | disconnect (IConnectionPoint *other) SMTG_OVERRIDE
tresult | notify (IMessage *message) SMTG_OVERRIDE

## Static Public Member Functions
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)
static FUnknown * | createInstance (void *)

## Public Attributes
OBJ_METHODS(Plug, AudioEffect) DEFINE_INTERFACES DEF_INTERFACE(Vst int32 | mPrefetchableMode
Public Attributes inherited from AudioEffect
OBJ_METHODS(AudioEffect, Component) DEFINE_INTERFACES DEF_INTERFACE(IAudioProcessor) DEF_INTERFACE(IProcessContextRequirements) END_DEFINE_INTERFACES(Component) REFCOUNT_METHODS(Component) protected ProcessContextRequirements | processContextRequirements
OBJ_METHODS(Component, ComponentBase) DEFINE_INTERFACES DEF_INTERFACE(IComponent) END_DEFINE_INTERFACES(ComponentBase) REFCOUNT_METHODS(ComponentBase) protected BusList | audioInputs
BusList | audioOutputs
BusList | eventInputs
BusList | eventOutputs
OBJ_METHODS(ComponentBase, FObject) DEFINE_INTERFACES DEF_INTERFACE(IPluginBase) DEF_INTERFACE(IConnectionPoint) END_DEFINE_INTERFACES(FObject) REFCOUNT_METHODS(FObject) protected IPtr < IConnectionPoint > | peerConnection
Public Attributes inherited from IProcessContextRequirements
| kNeedSystemTime
| kNeedContinousTimeSamples
| kNeedProjectTimeMusic
| kNeedBarPositionMusic
| kNeedCycleMusic
| kNeedSamplesToNextClock
| kNeedTempo
| kNeedTimeSignature
| kNeedChord
| kNeedFrameRate
| kNeedTransportState

## Protected Attributes
bool | bBypass
int32 | mLastNoteOnId
int32 | mLastNoteOnPitch
int32 | currentProgram
float | currentGainValue

## Additional Inherited Members
Public Types inherited from IProcessContextRequirements
enum | Flags
Static Public Attributes inherited from IPluginBase
static const FUID | iid
Static Public Attributes inherited from IConnectionPoint
static const FUID | iid
Static Public Attributes inherited from IComponent
static const FUID | iid
Static Public Attributes inherited from IAudioProcessor
static const FUID | iid
Static Public Attributes inherited from IProcessContextRequirements
static const FUID | iid
Static Public Attributes inherited from IPrefetchableSupport
static const FUID | iid

## Constructor & Destructor Documentation

Plug | ( |  | ) |

Plug | ( |  | ) |

Plug | ( |  | ) |

Plug | ( |  | ) |

## Member Function Documentation

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from AudioEffect.

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from AudioEffect.

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from AudioEffect.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from AudioEffect.

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from AudioEffect.

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from AudioEffect.

tresult sendTextMessage | ( | const char16 * | text | ) |

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from AudioEffect.

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from AudioEffect.

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from AudioEffect.

tresult getPrefetchableSupport | ( | PrefetchableSupport & | prefetchable | ) |
| virtual

Implements IPrefetchableSupport.

static FUnknown* createInstance | ( | void * |  | ) |
| inline static

tresult initialize | ( | FUnknown * | context | ) |
| virtual

Called at first after constructor.

Reimplemented from AudioEffect.

tresult process | ( | ProcessData & | data | ) |
| virtual

Here we go...the process call.

Reimplemented from AudioEffect.

tresult setState | ( | IBStream * | state | ) |
| virtual

For persistence.

Reimplemented from AudioEffect.

tresult getState | ( | IBStream * | state | ) |
| virtual

Reimplemented from AudioEffect.

## Member Data Documentation

bool bBypass
| protected

int32 mLastNoteOnId
| protected

int32 mLastNoteOnPitch
| protected

OBJ_METHODS (Plug, AudioEffect) DEFINE_INTERFACES DEF_INTERFACE (Vst int32 mPrefetchableMode

int32 currentProgram
| protected

float currentGainValue
| protected

Empty

Copyright ©2024 Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.